/* SPDX-License-Identifier: GPL-2.0-or-later */


#ifndef _ROLLING_BUFFER_H
#define _ROLLING_BUFFER_H

#include <linux/folio_queue.h>
#include <linux/uio.h>


struct rolling_buffer {
	struct folio_queue	*head;		
	struct folio_queue	*tail;		
	struct iov_iter		iter;		
	u8			next_head_slot;	
	u8			first_tail_slot; 
};


struct rolling_buffer_snapshot {
	struct folio_queue	*curr_folioq;	
	unsigned char		curr_slot;	
	unsigned char		curr_order;	
};


#define ROLLBUF_MARK_1	BIT(0)
#define ROLLBUF_MARK_2	BIT(1)

int rolling_buffer_init(struct rolling_buffer *roll, unsigned int rreq_id,
			unsigned int direction);
int rolling_buffer_make_space(struct rolling_buffer *roll);
ssize_t rolling_buffer_load_from_ra(struct rolling_buffer *roll,
				    struct readahead_control *ractl,
				    struct folio_batch *put_batch);
ssize_t rolling_buffer_append(struct rolling_buffer *roll, struct folio *folio,
			      unsigned int flags);
struct folio_queue *rolling_buffer_delete_spent(struct rolling_buffer *roll);
void rolling_buffer_clear(struct rolling_buffer *roll);

static inline void rolling_buffer_advance(struct rolling_buffer *roll, size_t amount)
{
	iov_iter_advance(&roll->iter, amount);
}

#endif 
